package sexpression;

public class Nil extends Cons {

    private static Nil uniqueInstance = new Nil();

    public static Nil getUniqueInstance() {
        return uniqueInstance;
    }

    private Nil() {
        super(null, null);

        super.setCar(this);
        super.setCdr(this);
    }

    public boolean nullp() {
        return true;
    }

    public boolean atomp() {
        return true;
    }

    public boolean consp() {
        return false;
    }

    public boolean symbolp() {
        return true;
    }

    /**
     * Set the car of this CONS cell to the specified value. This method does nothing (the car of
     * NIL can not be changed).
     */
    public void setCar(SExpression newCar) {}

    /**
     * Set the cdr of this CONS cell to the specified value. This method does nothing (the cdr of
     * NIL can not be changed).
     */
    public void setCdr(SExpression newCdr) {}

    public String toString() {
        return "NIL";
    }

}
